-- globals


gintTankWidth = 915		-- mm
gintTankHeight = 380	-- mm
gintTankDepth = 380		-- mm

gintScreenWidth = 800-- 1920
gintScreenHeight = 600 -- 1080

gintDrawingScale = math.min((gintScreenWidth / 915), (gintScreenHeight / 380))		-- multiply real world values by this to fit onto the screen			
gintDrawingScale = gintDrawingScale * 0.70		-- leave room for a small border

gintdrawingwidth = gintTankWidth * gintDrawingScale
gintdrawingheight = gintTankHeight * gintDrawingScale

TankX1 = (gintScreenWidth - (gintTankWidth * gintDrawingScale)) / 2					-- top left corner
TankY1 = gintScreenHeight - 50 - (gintTankHeight * gintDrawingScale)			-- 50 = offset

gintFishTileWidth = 128
gintFishTileHeight = 128

local drawobjects = {}

function drawobjects.drawwater()
		
	-- each 1L = 30 pixels on the Y axis
	local offset = 50		-- for that sweet 3D look
	
	local litreheight = gintdrawingheight / garrTank[1].totalvolume
	local wheight = litreheight * garrTank[1].watervolume		-- water height eg 2L = 60. Gives pixels
	
	local x1 = (gintScreenWidth - gintdrawingwidth) / 2					-- top left corner
	local y1 = gintScreenHeight - offset - gintdrawingheight
	
	local filterwidth = 50
	local filterheight = gintdrawingheight - offset - offset
	
	if wheight > filterheight or #garrFilter < 1 then
		-- x3 = x1
		-- y3 = y1 + gintdrawingheight - wheight	
	
		-- love.graphics.setColor(0,1,1,0.5)
		
		-- love.graphics.rectangle("fill",x1+offset,y1+gintdrawingheight-offset,gintdrawingwidth - offset, offset)	-- bottomwall
		
		-- love.graphics.rectangle("fill", x3,y3,gintdrawingwidth,wheight )		-- front 'wall'
		-- love.graphics.rectangle("fill", x3+offset, y3-offset, gintdrawingwidth, wheight)			-- back wall
		
		-- love.graphics.polygon("fill", x3,y3,x3+offset, y3-offset,x3+offset,y3)		-- left 'side'
		-- love.graphics.polygon("fill", x1+gintdrawingwidth,y1+gintdrawingheight,x1+gintdrawingwidth,y1+gintdrawingheight-offset,x1+gintdrawingwidth+offset,y1+gintdrawingheight-offset )

		-- top front left corner
		x2 = x1
		y2 = y1 + gintdrawingheight - wheight

		-- top back left corner
		x11 = x1 + offset
		y11 = y1 - offset + gintdrawingheight - wheight

		x6 = x1 + offset + gintdrawingwidth
		y6 = y11
		
		-- bottom back right corner of tank
		x8 = x6
		y8 = y6 + wheight	

		-- bottom front right corner of tank
		x9 = x8 - offset
		y9 = y8 + offset	

		-- bottom front left corner of tank
		x10 = x1
		y10 = y1 + gintdrawingheight

		love.graphics.setColor(0,1,1,0.5)
		love.graphics.polygon("fill",x2,y2,x11,y11,x6,y6,x8,y8,x9,y9,x10,y10)		-- draw in reverse order to avoid clipping		
	else
	
		-- top front left corner
		x2 = x1
		y2 = y1 + gintdrawingheight - wheight
		
		-- top front left corner of filter
		x3 = x2 + (offset / 2)
		y3 = y2 - (offset / 2)
		
		-- top front right corner of filter
		x4 = x3 + filterwidth
		y4 = y3	
		
		-- top back right corner of filter
		x5 = x4 + (offset / 2)
		y5 = y4 - (offset / 2)
		
		-- top back right corner of tank
		x6 = x5 + gintdrawingwidth - filterwidth
		y6 = y5
		
		-- top front right corner of tank
		--x7 = x6 - offset
		--y7 = y6 + offset
		
		-- bottom back right corner of tank
		x8 = x6
		y8 = y6 + wheight
		
		-- bottom front right corner of tank
		x9 = x8 - offset
		y9 = y8 + offset
		
		-- bottom front left corner of tank
		x10 = x1
		y10 = y1 + gintdrawingheight
		

		love.graphics.setColor(0,1,1,0.5)
		love.graphics.polygon("fill",x8,y8,x9,y9,x10,y10,x2,y2,x3,y3,x4,y4,x5,y5,x6,y6)	-- draw in reverse order to avoid clipping
	end
	
	-- for fun - a line on the front waterline
	love.graphics.setColor(0,1,1,0.5)
	love.graphics.line(x1,y1 + gintdrawingheight - wheight,x1+gintdrawingwidth, y1 + gintdrawingheight - wheight)
	love.graphics.line(x1+gintdrawingwidth, y1 + gintdrawingheight - wheight ,x1+gintdrawingwidth + offset, y1 + gintdrawingheight - wheight - offset)
	


end

local function drawtimer()
-- draw timer in corner

	local mins = math.floor(gfltGlobalTimer / 60)
	local secs = cf.round(gfltGlobalTimer - (mins * 60),0)
	love.graphics.setColor(1,1,1,1)
	love.graphics.print(mins .. ":" .. secs, 700, 10)

end

function drawobjects.drawtank()
	-- 915mm * 380mm * 380mm
	
	local width = gintdrawingwidth
	local height = gintdrawingheight
	local offset = 50		-- for that sweet 3D look
	
	local x1 = (gintScreenWidth - width) / 2					-- top left corner
	local y1 = gintScreenHeight - offset - height
	
	local x2 = x1 + offset		-- back top left corner
	local y2 = y1 - offset
	
	love.graphics.setColor(1,1,1,1)
	love.graphics.rectangle("line", x1, y1, width, height)	
	love.graphics.rectangle("line", x2, y2, width, height)
	love.graphics.line(x1,y1,x2,y2)
	love.graphics.line(x1+width,y1,x2+width,y2)
	love.graphics.line(x1,y1+height,x2,y2+height)
	love.graphics.line(x1+width,y1+height,x2+width,y2+height)	

	if gintHours ~= nil then		-- for save game compatibility
		love.graphics.setColor(1,1,1,1)
		love.graphics.print("Hour: " .. gintHours, 650, 10)
	else
		gintHours = 0
	end
	
	if gbolShowData then
		-- draw metrics
		local yvalue = 125
		love.graphics.setColor(1,1,1,1)
		love.graphics.print("Hardness (mg): " .. garrTank[1].GH, 10,yvalue)
		love.graphics.print("pH: " .. cf.round(garrTank[1].PH,1), 10,yvalue + 15)
		love.graphics.print("Chlorine: " .. cf.round(garrTank[1].chlorine,3) .. " mg / " ..  cf.round((garrTank[1].chlorine / garrTank[1].watervolume),3) .. " ppm"   , 10,yvalue + 30)
		love.graphics.print("Chloramine: " .. cf.round(garrTank[1].chloramine,3) .. " mg / " .. cf.round((garrTank[1].chloramine / garrTank[1].watervolume),3) .. " ppm", 10,yvalue + 45)
		local tmpstring = "Ammonia: " .. cf.round(garrTank[1].ammonia,3) .. " mg / " .. cf.round((garrTank[1].ammonia / garrTank[1].watervolume),3) .. " ppm"
		love.graphics.print(tmpstring, 10,yvalue + 60)
		
		if #garrFilter > 0 then
			love.graphics.print("Bacteria A (mg): " .. cf.round(garrFilter[1].bacteriaA,2), 10,yvalue + 75)	
			love.graphics.print("Bacteria B (mg): " .. cf.round(garrFilter[1].bacteriaB,2), 10,yvalue + 90)	
			love.graphics.print("Nitrite (mg): " .. cf.round(garrTank[1].nitrite,3), 10,yvalue + 105)
			love.graphics.print("Nitrate (mg): " .. cf.round(garrTank[1].nitrate,3), 10,yvalue + 120)			
		end
		
		drawtimer()
		
	end

end

function drawobjects.drawbucket()

	local x1 = 200
	local y1 = 200
	local x2 = 200
	local y2 = 500
	
	love.graphics.setColor(1,1,1,1)
	love.graphics.line(x1,y1,x2,y2)
	
	x1 = 600
	y1 = 200
	x2 = 600
	y2 = 500
	
	love.graphics.setColor(1,1,1,1)
	love.graphics.line(x1,y1,x2,y2)

	x1 = 200
	y1 = 500
	x2 = 600
	y2 = 500	

	love.graphics.setColor(1,1,1,1)
	love.graphics.line(x1,y1,x2,y2)
	
	love.graphics.print("10L bucket", 375, 525)
	
	-- draw water
	-- each 1L = 30 pixels on the Y axis
	x1 = 200
	local wheight = 30 * garrTank[2].watervolume		-- eg 2L = 60
	y1 = 500 - wheight

	love.graphics.setColor(0,0,1,1)
	love.graphics.rectangle("fill", x1,y1, 400,wheight )
	
	if gbolShowData then
		-- draw metrics
		local y2 = 190
		love.graphics.setColor(1,1,1,1)
		love.graphics.print("Hardness (mg): " .. garrTank[2].GH, 10,y2)
		love.graphics.print("pH: " .. garrTank[2].PH, 10,75)
		love.graphics.print("Chlorine (mg): " .. garrTank[2].chlorine, 10,y2 + 15)
		love.graphics.print("Chloramine (mg): " .. garrTank[2].chloramine, 10,y2 + 30)
		love.graphics.print("Nitrite (mg): " .. garrTank[2].nitrite, 10,y2 + 45)
		love.graphics.print("Nitrate (mg): " .. garrTank[2].nitrate, 10,y2 + 60)

	end
	drawtimer()

end

function drawobjects.drawinstructions()
	
	local tmpstr = ""
	
	if gstrCurrentScreen == "Tank" then
	
		tmpstr = tmpstr .. "1 = display bucket" .. "\n"
		tmpstr = tmpstr .. "5 = add bucket water to tank" .. "\n"
		tmpstr = tmpstr .. "6 = add one fish" .. "\n"
		tmpstr = tmpstr .. "7 = remove 10L of water" .. "\n"
		tmpstr = tmpstr .. "8 = check ammonia strip" .. "\n"
		
		
		tmpstr = tmpstr .. "mouse = add one food pellet" .. "\n"
	end
	if gstrCurrentScreen == "Bucket" then
		tmpstr = tmpstr .. "2 = add tapwater to bucket" .. "\n"
		tmpstr = tmpstr .. "3 = remove tapwater from bucket" .. "\n"
		tmpstr = tmpstr .. "4 = age water by 1 hour" .. "\n"
		tmpstr = tmpstr .. "d = add dechlorinator" .. "\n"
		tmpstr = tmpstr .. "esc = go back to tank" .. "\n"
	end
	
	love.graphics.setColor(1,1,1,1)
	love.graphics.print(tmpstr, 10,10)
	
	
	local tmpstr = ""
	
	if gstrCurrentScreen == "Tank" then
		tmpstr = tmpstr .. "d = add dechlorinator" .. "\n"
		tmpstr = tmpstr .. "f = add filter" .. "\n"
		tmpstr = tmpstr .. "l = load game" .. "\n"
		tmpstr = tmpstr .. "s = save game" .. "\n"
		tmpstr = tmpstr .. "kp- = tank volume down" .. "\n"
		tmpstr = tmpstr .. "kp+ = tank volume up" .. "\n"
	end
	love.graphics.setColor(1,1,1,1)
	love.graphics.print(tmpstr, 300,10)
end

function drawobjects.drawfish()

	
	for k,v in ipairs(garrFish) do
	
		-- draw fish in centre and not on corner
		local x1 = v.x - (gintFishTileWidth * v.growth / 2)
		local y1 = v.y - (gintFishTileHeight * v.growth / 2)
		
		local xoffset = (gintFishTileWidth * v.growth / 2)
		local yoffset = (gintFishTileHeight * v.growth / 2)	
	
	
		if v.dead then
			FishAnimationDead:draw(FishSpriteSheet, v.x, v.y,0,v.growth,v.growth)		--x,y rotate, scale x, scale y
		else
		
			local fishrotation = 0
			local chlorineppm = cf.round((garrTank[1].chlorine / garrTank[1].watervolume),3)
			local chloramineppm = cf.round((garrTank[1].chloramine / garrTank[1].watervolume),3)


			if v.heading == "right" then
				if chlorineppm > 0.1 or chloramineppm > 0.0035 then
					fishrotation = -1
					FishAnimationRight:draw(FishSpriteSheet, x1, y1 + yoffset, fishrotation, v.growth, v.growth)		--x,y rotate, scale x, scale y
				else
					FishAnimationRight:draw(FishSpriteSheet, x1, y1, 0, v.growth, v.growth)		--x,y rotate, scale x, scale y
				end
				
			else
				if chlorineppm > 0.1 or chloramineppm > 0.0035 then
					fishrotation = 1
					FishAnimationLeft:draw(FishSpriteSheet, x1 + xoffset, y1, fishrotation, v.growth, v.growth)		--x,y rotate, scale x, scale y
				end			
				FishAnimationLeft:draw(FishSpriteSheet, x1, y1, 0, v.growth, v.growth)		--x,y rotate, scale x, scale y
			end
			
			--love.graphics.setColor(1,1,1,1)
			--love.graphics.circle("fill", v.x,v.y, 3)
			
			if gbolShowData then
				local yvalue = 0
				love.graphics.setColor(1,1,1,1)
				love.graphics.print("TargetX: " .. v.targetx, x1 + 14, y1 + yvalue)
				love.graphics.print("Fullness: " .. v.fullness, x1 + 14, y1 + yvalue + 15)
				love.graphics.print("Hunting: " .. tostring(v.hunting), x1 + 14, y1 + yvalue + 30)
				love.graphics.print("Growth: " .. v.growth, x1 + 14, y1 + yvalue + 45)
			end				
		end

	end
end

function drawobjects.drawfood()
	love.graphics.setColor(1,1,0,1)
	for k,v in ipairs(garrFood) do
		love.graphics.points(v.x,v.y)
	end
end

function drawobjects.drawammoniastrip(tank)

	-- draw the whole card (bground)
	local width = 300
	local height = 275

	-- local x1 = 275
	local x1 = (gintScreenWidth / 2) - (width / 2)
	local y1 = 150
	
	-- background
	love.graphics.setColor(227/255,226/255,222/255,1)
	love.graphics.rectangle("fill", x1,y1,width,height)
	
	-- text
	local lineheight = 35
	local topmargin = 30
	love.graphics.setColor(10/255,98/255,74/255,1)
	love.graphics.print("0 ppm", x1 + 10, y1 + topmargin + lineheight * 0)
	love.graphics.print("0.25", x1 + 10, y1 + topmargin + lineheight * 1)
	love.graphics.print("0.50", x1 + 10, y1 + topmargin + lineheight * 2)
	love.graphics.print("1.0", x1 + 10, y1 + topmargin + lineheight * 3)
	love.graphics.print("2.0", x1 + 10, y1 + topmargin + lineheight * 4)
	love.graphics.print("4.0", x1 + 10, y1 + topmargin + lineheight * 5)
	love.graphics.print("8.0", x1 + 10, y1 + topmargin + lineheight * 6)

	-- colour squares
	local topmargin1 = 25
	local x2 = x1 + 55
	local y2 = y1 + topmargin1 + lineheight * 0
	local lineheight1 = lineheight / 2
	love.graphics.setColor(248/255, 223/255, 61/255, 1)
	love.graphics.rectangle("fill", x2, y2, 75, 25)
	
	love.graphics.setColor(219/255, 221/255, 0/255, 1)
	love.graphics.rectangle("fill", x2, y2 + lineheight1 * 2, 75, 25)	
	
	love.graphics.setColor(189/255, 219/255, 1/255, 1)
	love.graphics.rectangle("fill", x2, y2 + lineheight1 * 4, 75, 25)		
	
	love.graphics.setColor(118/255, 211/255, 45/255, 1)
	love.graphics.rectangle("fill", x2, y2 + lineheight1 * 6, 75, 25)	
	
	love.graphics.setColor(1/255, 179/255, 65/255, 1)
	love.graphics.rectangle("fill", x2, y2 + lineheight1 * 8, 75, 25)	
	
	love.graphics.setColor(0/255, 164/255, 51/255, 1)
	love.graphics.rectangle("fill", x2, y2 + lineheight1 * 10, 75, 25)	
	
	love.graphics.setColor(0/255, 112/255, 90/255, 1)
	love.graphics.rectangle("fill", x2, y2 + lineheight1 * 12, 75, 25)	
	
	-- colour strip
	
	
	local x3 = x2 + 125
	local y3 = y2 + 25
	local width3 = 50
	local height3 = 150
	
	love.graphics.setColor(0, 0, 0, 1)
	love.graphics.print("Strip", x3 + 8, y3 - 20)
	
	local red,green,blue
	love.graphics.setColor(1, 1, 1, 1)
	love.graphics.rectangle("fill", x3,y3,width3,height3)
	
	-- colour bit based on garrTank[tank].ammonia
	-- determine colour
	local myPH = cf.round((garrTank[1].ammonia / garrTank[1].watervolume),3) * love.math.random(0.95, 1.05)
	if myPH <= 0.125 then
		red = 248/255
		green = 223/255
		blue = 61/255
	elseif myPH > 0.125 and myPH <= 0.325 then
		red = 219/255
		green = 221/255
		blue = 0/255
	elseif myPH > 0.325 and myPH <= 0.75 then
		red = 189/255
		green = 219/255
		blue = 1/255
	elseif myPH > 0.75 and myPH <= 1.5 then
		red = 118/255
		green = 211/255
		blue = 45/255
	elseif myPH > 1.5 and myPH <= 3.0 then
		red = 1/255
		green = 179/255
		blue = 65/255
	elseif myPH > 3.0 and myPH <= 6.0 then
		red = 0/255
		green = 164/255
		blue = 51/255
	else
		red = 0/255
		green = 112/255
		blue = 90/255
	end
	
	local bandstart = 50
	local bandheight = 25
	
	love.graphics.setColor(red,green,blue, 0.10)
	love.graphics.rectangle("fill", x3, y3 + bandstart,       width3, bandheight / 2)

	love.graphics.setColor(red,green,blue, 0.20)
	love.graphics.rectangle("fill", x3, y3 + bandstart * 1.25,width3, bandheight / 2)	
	
	love.graphics.setColor(red,green,blue, 0.40)
	love.graphics.rectangle("fill", x3, y3 + bandstart * 1.5,width3, bandheight )		

	love.graphics.setColor(red,green,blue, 0.60)
	love.graphics.rectangle("fill", x3, y3 + bandstart * 2,width3, bandheight)	
	
	love.graphics.setColor(red,green,blue, 0.80)
	love.graphics.rectangle("fill", x3, y3 + bandstart * 2.5,width3, bandheight)	

	love.graphics.setColor(red,green,blue, 1)
	love.graphics.rectangle("fill", x3, y3 + bandstart * 3,width3, bandheight)
	
	-- draw colours from bottom up
	-- love.graphics.setColor(red,green,blue, 1)
	-- love.graphics.rectangle("fill", x3, y3 + bandstart,width3,bandheight * 2)
	
	-- love.graphics.setColor(red,green,blue, 0.80)
	-- love.graphics.rectangle("fill", x3, y3 + bandstart - bandheight * 3,width3,bandheight)
	
	-- love.graphics.setColor(red,green,blue, 0.60)
	-- love.graphics.rectangle("fill", x3, y3 + bandstart - (bandheight * 4),width3,bandheight)	
	
	-- love.graphics.setColor(red,green,blue, 0.40)
	-- love.graphics.rectangle("fill", x3, y3 + bandstart - (bandheight * 5),width3,bandheight)
	
	-- love.graphics.setColor(red,green,blue, 0.20)
	-- love.graphics.rectangle("fill", x3, y3 + bandstart - (bandheight * 6),width3,bandheight)
	
	-- love.graphics.setColor(red,green,blue, 0.10)
	-- love.graphics.rectangle("fill", x3, y3 + bandstart - (bandheight * 7),width3,bandheight)
	

	
end

function drawobjects.drawfilter()


	local offset = 50		-- for that sweet 3D look
	local filterwidth = 50
	local filterheight = gintdrawingheight - offset - offset
	
	local x1 = (gintScreenWidth - gintdrawingwidth) / 2					-- top left corner
	local y1 = gintScreenHeight - offset - gintdrawingheight
	
	-- this is the 'back' of the filter
	local x2 = x1 + offset		-- back top left corner
	local y2 = y1 + offset
	
	--love.graphics.circle("fill", x1,y1, 5)
	--love.graphics.circle("fill", x2,y2, 5)
	
	local x3 = x2 + filterwidth
	local y3 = y2
	--love.graphics.circle("fill", x3,y3, 5)

	local x4 = x3
	local y4 = y3 + filterheight
	--love.graphics.circle("fill", x4,y4, 5)
	
	local x5 = x4 - filterwidth
	local y5 = y4
	--love.graphics.circle("fill", x5,y5, 5)
	
	
	
	-- this is the 'front' of the filter
	x12 = x2 - (offset / 2)
	y12 = y2 + (offset / 2)
	--love.graphics.circle("fill", x12,y12, 5)
	
	x13 = x3 - (offset / 2)
	y13 = y3 + (offset / 2)
	--love.graphics.circle("fill", x13,y13, 5)	
	
	x14 = x4 - (offset / 2)
	y14 = y4 + (offset / 2)
	--love.graphics.circle("fill", x14,y14, 5)

	x15 = x5 - (offset / 2)
	y15 = y5 + (offset / 2)
	--love.graphics.circle("fill", x15,y15, 5)	
	
	-- shading
	love.graphics.setColor(166/255,166/255,166/255)
	love.graphics.rectangle("fill",x12,y12,filterwidth,filterheight)
	love.graphics.rectangle("fill",x2,y2,filterwidth,filterheight)
	love.graphics.polygon("fill",x2,y2,x12,y12,x2,y12)
	love.graphics.polygon("fill",x3,y4,x14,y14,x5,y5)	
	
	-- front panel
	love.graphics.setColor(70/255,56/255,56/255)
	love.graphics.line(x12,y12,x13,y13,x14,y14,x15,y15,x12,y12)
	-- back panel
	love.graphics.line(x2,y2,x3,y3,x4,y4,x14,y14)
	-- top edges
	love.graphics.line(x2,y2,x12,y12)
	love.graphics.line(x3,y3,x13,y13)
	

	

end

function drawobjects.drawwave()
-- draw surface waves with sine

	-- local gintSineOffset = -1
	-- if gfltMovementTimerFish >= 0 and gfltMovementTimerFish <= 0.06 then 
		-- gintSineOffset = 0
	-- elseif gfltMovementTimerFish > 0.06 and gfltMovementTimerFish <= 0.12 then 
		-- gintSineOffset = 1
	-- elseif gfltMovementTimerFish > 0.12 and gfltMovementTimerFish <= 0.18 then
		-- gintSineOffset = 2
	-- else
		-- gintSineOffset = 1
	-- end
	
	local litreheight = gintdrawingheight / garrTank[1].totalvolume
	local wheight = litreheight * garrTank[1].watervolume		-- water height eg 2L = 60. Gives pixels
	
	local offset = 50		-- for that sweet 3D look
	local filterwidth = 50
	local x2 = (TankX1 + offset + filterwidth ) * 1.33
	local y2 = TankY1 + gintdrawingheight - wheight
	
	for i = x2 , (x2 * 2) do
		
		-- draw sine wave
		local y = math.sin(gintSineOffset + i * 6) * 2
	
		x3 = i + gintSineOffset
		y3 = y2 + y
		
		love.graphics.setColor(0,1,1,0.5)
		love.graphics.circle("fill", x3,y3, 1)
		love.graphics.circle("fill", x3 + offset, y3 - offset, 1)
		
		if y > 0 and garrWave[i] ~= nil then
			love.graphics.line(garrWave[i].x4,garrWave[i].y4,garrWave[i].x5,garrWave[i].y5)
		end

	end
	
	for k,v in pairs(garrWave) do
		--love.graphics.line(garrWave[k].x4,garrWave[k].y4,garrWave[k].x5,garrWave[k].y5)
		--love.graphics.circle("fill", garrWave[k].x4,garrWave[k].y4, 1)
	end
end
	


return drawobjects


