local randomfunctions = {}

function randomfunctions.AddScreen(strNewScreen)
	table.insert(garrCurrentScreen, strNewScreen)
end

function randomfunctions.RemoveScreen()
	
	if #garrCurrentScreen > 1 then
		table.remove(garrCurrentScreen)
	end
	if #garrCurrentScreen < 1 then
		if success then
			love.event.quit()       --! this doesn't dothe same as the EXIT button
		end
	end
end

function randomfunctions.GetWaterY()
-- returns the drawing y value for the current waterlevel

	local litreheight = gintdrawingheight / garrTank[1].totalvolume
	local wheight = litreheight * garrTank[1].watervolume		-- water height eg 2L = 60. Gives pixels
	return TankY1 + gintdrawingheight - wheight

end

function randomfunctions.GetTankBottomY()
-- returns the drawing y value of the bottom of the tank
	return (TankY1 + gintdrawingheight)
end


function randomfunctions.SaveGame()
-- uses the globals because too hard to pass params
    
    local savefile
    local contents
    local success, message
    local savedir = love.filesystem.getSource()
  
    savefile = savedir .. "/" .. "tank.dat"
    serialisedString = bitser.dumps(garrTank)
    success, message = nativefs.write(savefile, serialisedString )
    
    savefile = savedir .. "/" .. "fish.dat"
    serialisedString = bitser.dumps(garrFish)
    success, message = nativefs.write(savefile, serialisedString )
 
    savefile = savedir .. "/" .. "gamesettings.dat"
    serialisedString = bitser.dumps(garrGameSettings)
    success, message = nativefs.write(savefile, serialisedString )
 
    savefile = savedir .. "/" .. "filter.dat"
    serialisedString = bitser.dumps(garrFilter)
    success, message = nativefs.write(savefile, serialisedString )
end

function randomfunctions.LoadGame()
    
    local savedir = love.filesystem.getSource()
    love.filesystem.setIdentity( savedir )
    
    local savefile
    local contents
	

    savefile = savedir .. "/" .. "gamesettings.dat"
    contents, _ = nativefs.read(savefile) 
	local bolSuccess, retval = pcall(bitser.loads, contents)
	
	if bolSuccess then
		garrGameSettings = retval

		local saveversion = tonumber(garrGameSettings.gameversion)
		local gameversion = tonumber(gstrGameVersion)

		if (saveversion == gameversion) or 
			(saveversion == 0.05) or
			(saveversion == 0.06) then

			savefile = savedir .. "/" .. "tank.dat"
			contents, _ = nativefs.read( savefile) 
			garrTank = bitser.loads(contents)    

			savefile = savedir .. "/" .. "fish.dat"
			contents, _ = nativefs.read( savefile) 
			garrFish = bitser.loads(contents) 
			
			savefile = savedir .. "/" .. "filter.dat"
			contents, _ = nativefs.read( savefile) 
			--garrFilter = bitser.loads(contents) 
			
			local bolSuccess, retval = pcall(bitser.loads, contents)
			if bolSuccess then
				garrFilter = retval
			else
				garrFilter = {}
			end
			lovelyToasts.show("Game loaded", 3, "bottom", gintScreenWidth)		-- text, duration, y or "bottom", screenwidth			
		end
	else
		lovelyToasts.show("Load failed", 3, "bottom", gintScreenWidth)		-- text, duration, y or "bottom", screenwidth
	end
		
	
	
end




return randomfunctions


